"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.inlineFiles = void 0;
const parse_comment_as_sandbox_options_1 = require("./parse-comment-as-sandbox-options");
const fs = __importStar(require("fs"));
const path_1 = __importDefault(require("path"));
const escapeHTMLComment = (content) => {
    // It will be restored when parsing comment
    // to avoid break -->
    return content.split("<!--").join("\\u003c\\u0021\\u002d\\u002d").split("-->").join("\\u002d\\u002d\\u003e");
};
const inlineFiles = (content, filePath) => {
    const baseDir = path_1.default.dirname(filePath);
    const commentPattern = /<!--\s?(sandpack:{[\s\S]*?})\s?-->/g;
    return content.replace(commentPattern, (_, match) => {
        const options = (0, parse_comment_as_sandbox_options_1.parseCommentAsSandboxOptions)(match.trim());
        const inlinedFiles = Object.fromEntries(Object.entries(options.files).map((entry) => {
            const fileName = entry[0];
            const { prependCode, path: importPath, appendCode, ...originalProps } = entry[1];
            const loadedCode = importPath
                ? escapeHTMLComment(fs.readFileSync(path_1.default.resolve(baseDir, importPath), "utf-8"))
                : originalProps.code;
            const code = (prependCode ?? "") + loadedCode + (appendCode ?? "");
            return [
                fileName,
                {
                    ...originalProps,
                    code
                }
            ];
        }));
        const updatedOptions = {
            ...options,
            files: inlinedFiles
        };
        return `<!-- sandpack:${JSON.stringify(updatedOptions)} -->`;
    });
};
exports.inlineFiles = inlineFiles;
//# sourceMappingURL=hook-inline.js.map