"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseCommentAsSandboxOptions = void 0;
function parseCommentAsSandboxOptions(comment) {
    const CONSOLE_METADATA = /sandpack:({[\s\S]+})$/;
    const optionString = comment.match(CONSOLE_METADATA);
    if (!optionString) {
        throw new Error(`Does not match sandpack comment.
sandpack:{ ... } should be json string.
Actual: ${comment}
`);
    }
    try {
        const json = JSON.parse(optionString[1]
            .split("\\\\u003c\\\\u0021\\\\u002d\\\\u002d")
            .join("<!--")
            .split("\\\\u002d\\\\u002d\\\\u003e")
            .join("-->"));
        return {
            ...json
        };
    }
    catch (error) {
        throw new Error(`Can not parsed the metadata.
sandpack:{ ... } should be json string.
Actual: ${comment}
Error: ${error.message}
`);
    }
}
exports.parseCommentAsSandboxOptions = parseCommentAsSandboxOptions;
//# sourceMappingURL=parse-comment-as-sandbox-options.js.map