import type { SandboxInfo } from "@codesandbox/sandpack-client";
export declare type SandboxOptions = {
    files: Record<string, {
        code: string;
        readOnly?: boolean;
    } & {
        prependCode?: string;
        path?: string;
        appendCode?: string;
    }>;
    dependencies?: SandboxInfo["dependencies"];
    devDependencies?: SandboxInfo["devDependencies"];
    entry?: string;
    /**
     * What template we use, if not defined we infer the template from the dependencies or files.
     */
    template?: string;
    options?: Record<string, any>;
    honkitSettings?: {
        isOpen: boolean;
        hideExitButton: boolean;
        hideRunButton: boolean;
    };
};
export declare const attachToElement: (element: HTMLElement | ChildNode, options: SandboxOptions) => void;
